unit uXmlUtils;

interface

uses XMLIntf, XMLDoc;

const cXmlHead='<?xml version="1.0" encoding="windows-1250"?>';

Function GetAttribute(Node:IXMLNode; AttributeName:String; DefaultValue:Variant):Variant;
Function GetFirstNode(Node:IXMLNode; ChildName:String=''; CaseSensitive:boolean=False):IXMLNode;
Procedure ReplaceNode(var destNode:IXMLNode; source:String);

implementation

uses Sysutils;

Function GetAttribute(Node:IXMLNode; AttributeName:String; DefaultValue:Variant):Variant;
begin
  Result:=DefaultValue;
  If Assigned(Node) and Node.HasAttribute(AttributeName)
   then Result:=Node.Attributes[AttributeName];
end;

Function GetFirstNode(Node:IXMLNode; ChildName:String; CaseSensitive:boolean):IXMLNode;
begin
  Result:=Nil;
  If Assigned(Node) then Result:=Node.ChildNodes.First;
  if ChildName<>'' then
   if CaseSensitive
    then While Assigned(Result) and (Result.NodeName<>ChildName) do Result:=Result.NextSibling
    else While Assigned(Result) and (UpperCase(Result.NodeName)<>UpperCase(ChildName)) do Result:=Result.NextSibling
end;

Procedure ReplaceNode(var destNode:IXMLNode; source:String);
Var Dom:IXMLDocument;
    ParentNode:IXMLNode;
    I:Integer;
begin
  If Assigned(destNode) then
  begin
    If Assigned(destNode.ParentNode) then
    begin
      Dom:=TXMLDocument.Create(nil);
      DOm.Active:=False;
      DOM.XML.Clear;
      Dom.XML.Text:=source;
      DOm.Active:=True;
      ParentNode:=destNode.ParentNode;
      i:=ParentNode.ChildNodes.IndexOf(destNode);
      ParentNode.ChildNodes.Delete(i);
      destNode:=DOm.DocumentElement.CloneNode(True);
      ParentNode.ChildNodes.Insert(I,destNode);
    end
    else
    begin
      Dom:=destNode.OwnerDocument;
      Dom.Active:=False;
      Dom.XML.Text:=source;
      DOm.Active:=True;
      destNode:=Dom.DocumentElement;
    end;
  end;
end;


end.




